do
	local super=TRAININGGROUNDS_Mobile
	TRAININGGROUNDS_JAINA_Mobile_Jaina=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JAINA_Mobile_Jaina

	function class:GetName()
		--override, don't call super
		return "Jaina (mobile) "..tostring(self.id)
	end
	

	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.nameplatename="Jaina"
		self.basemovespeed = 1.5 * TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(7.0)
		self.hitboxradius=TRAININGGROUNDS_Mobile_StandardHitboxRadius*10.0
		--self.hitboxradius=TRAININGGROUNDS_Mobile_StandardHitboxRadius*4.0
		--self.hitboxradius=TRAININGGROUNDS_Mobile_StandardHitboxRadius*3.0
		--self.baseturnspeed=2.0	
		--self.baseturnspeed_3D=2.0	
		--self.faction=TRAININGGROUNDS_Factions.ENEMY
		
		--set after calling setup: 
		self.groupdancemodule=nil	-- (used when spells create further objects)		
	end
	
	function class:CreateAI()
		self.ai=TRAININGGROUNDS_AI_Boss.new()
		self.ai:Setup(self,environment)
	end		
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_JAINA_Drawable_Jaina.new()
		self.drawable:Setup(self,self.environment)
	end
	
	-- function class:CreateCombatModule()
		-- self.combat=TRAININGGROUNDS_JAINA_CombatModule_Jaina.new()
		-- self.combat:Setup(self)
	-- end
end

do
	--TODO: move to content/aggramar
	TRAININGGROUNDS_JAINA_ANIMATION_LIST={}


	-- local stand=TRAININGGROUNDS_AnimationSequence_QuickSetup(TRAININGGROUNDS_JAINA_ANIMATION_LIST,"Stand",0,nil,TRAININGGROUNDS_ANIMATION_PRIORITY.TELEGRAPH,nil)	
	-- local stance=TRAININGGROUNDS_AnimationSequence_QuickSetup(TRAININGGROUNDS_JAINA_ANIMATION_LIST,"Stance",51,nil,TRAININGGROUNDS_ANIMATION_PRIORITY.TELEGRAPH,nil)
	-- local loop=TRAININGGROUNDS_AnimationSequence_QuickSetup(TRAININGGROUNDS_JAINA_ANIMATION_LIST,"Jaina",125,nil,TRAININGGROUNDS_ANIMATION_PRIORITY.TELEGRAPH,nil)
	


	if(not TRAININGGROUNDS_ModelInfos.Jaina)then
		local mi
		mi=TRAININGGROUNDS_ModelInfo.new()
		mi:Setup()
		mi.displayid=87892
		mi.cameradistance=15
		mi.size=150
		mi.shadowsize=mi.size*0.75
		
		mi.clickboxx=0
		mi.clickboxy=-5
		mi.clickboxwidth=32
		mi.clickboxheight=52
		
		TRAININGGROUNDS_ModelInfos.Jaina=mi
		TRAININGGROUNDS_ModelInfos:Add(mi.displayid,mi)
	end

	local super=TRAININGGROUNDS_Drawable_CharacterModel
	TRAININGGROUNDS_JAINA_Drawable_Jaina = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JAINA_Drawable_Jaina 
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.scale3D=1.5	--TODO: move to modelinfo
		--self.positionmultiplier=0.9
		self.positionmultiplier=1/self.scale3D
	end
	
	function class:SetFrameAppearance()	
		self.modelinfo=TRAININGGROUNDS_ModelInfos.Jaina
		self.frame:SetDisplayInfo(self.modelinfo.displayid)	
	end
	
	-- function class:Get3DPositionCoords()
		-- local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
		-- return self.x,self.y,self.z+yard*0.25
	-- end
end

----------------------------------
----------------------------------
----------------------------------
----------------------------------
----------------------------------



-- do
	-- local super=TRAININGGROUNDS_GameObject
	-- TRAININGGROUNDS_JAINA_Decor_Floor=TRAININGGROUNDS_inheritsFrom(super)
	-- local class=TRAININGGROUNDS_JAINA_Decor_Floor
	
	-- function class:SetCustomInfo()
		-- super.SetCustomInfo(self)
		-- self.alivetime=0
		-- self.state=0
		-- self.width=100
		-- self.height=100
	-- end

	-- function class:SetDrawable()
		-- --self.drawable=TRAININGGROUNDS_JAINA_Drawable_Floor.new()
		-- self.drawable=TRAININGGROUNDS_Drawable_Sprite_BigCircle.new()
		-- self.drawable:Setup(self,self.environment)
		-- self.drawable:SetColor(0.75,0.75,1,1)
	-- end
	
-- end


-- do
	-- local super=TRAININGGROUNDS_Drawable_SpellEffect
	-- TRAININGGROUNDS_JAINA_Drawable_Floor=TRAININGGROUNDS_inheritsFrom(super)	
	-- local class=TRAININGGROUNDS_JAINA_Drawable_Floor
	
	-- function class:SetCustomInfo()
		-- super.SetCustomInfo(self)
		-- self.anchor="CENTER"
		-- self.selected=false		
		
		-- -- self.modelfilename="world/expansion06/doodads/dungeon/doodads/7du_tombofsargeras_councilfloor01.m2"		
		-- -- --self.scale3D=0.75	--TODO: probably move to modelinfo
		-- -- self.scale3D=1.0--TODO: probably move to modelinfo
		-- -- self.positionmultiplier=1	--TODO: move to modelinfo
		-- -- --self.camerapositionmultiplier=0.45	--TODO: move to modelinfo
		-- -- self.camerapositionmultiplier=0.45	--TODO: move to modelinfo
		-- -- self.zsortoffset3D=10	--measured in yards.  TODO: move to modelinfo

		-- -- -- Frozen Orb telegraph
		-- -- self.modelfilename="spells/8fx_jaina_frozenorb_precast.m2"		
		-- -- --self.scale3D=0.75	--TODO: probably move to modelinfo
		-- -- self.scale3D=0.25	--TODO: probably move to modelinfo
		-- -- self.positionmultiplier=0.45/self.scale3D	--TODO: move to modelinfo
		-- -- self.camerapositionmultiplier=0.45	--TODO: move to modelinfo
		-- -- self.zsortoffset3D=10	--measured in yards.  TODO: move to modelinfo	
		-- -- self.defaultanimation=158	--TODO: 
		
		-- -- self.modelfilename="spells/8fx_jaina_ringoffrost.m2"		
		-- -- --self.scale3D=0.75	--TODO: probably move to modelinfo
		-- -- self.scale3D=1	--TODO: probably move to modelinfo
		-- -- self.positionmultiplier=1	--TODO: move to modelinfo
		-- -- self.camerapositionmultiplier=0.35	--TODO: move to modelinfo
		-- -- self.zsortoffset3D=10	--measured in yards.  TODO: move to modelinfo	
		-- -- self.defaultanimation=158
		

	-- end
	
	-- -- -- for zandalarraid_elevator only
	-- -- function class:Get3DPositionCoords()
		-- -- local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
		-- -- return self.x,self.y,self.z+yard*-0.625
	-- -- end	
	
	
	-- function class:SetFrameLayer()
		-- self.framelayer=self.owner.environment.cameramanager.arenaborderframelayer
	-- end
	
-- end