

do

	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
	local REDX="\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_7:12\124t"
	local INTRO_TIME_MULTIPLIER=1.0
--local INTRO_TIME_MULTIPLIER=0.1
	--local CENTERCIRCLE_HEIGHT=0
	local CENTERCIRCLE_HEIGHT=1*yard
	local PLAYER_DISTANCE=yard*22

	TRAININGGROUNDS_STORMWALLBLOCKADE_CustomDanceEventType={}
	local i=0
	i=i+1;TRAININGGROUNDS_STORMWALLBLOCKADE_CustomDanceEventType.SEASWELL=i
	i=i+1;TRAININGGROUNDS_STORMWALLBLOCKADE_CustomDanceEventType.SOAK_TIDEPOOL=i

	
	local super=TRAININGGROUNDS_GroupDanceModule	
	TRAININGGROUNDS_STORMWALLBLOCKADE_GroupDanceModule_StormsWail=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_GroupDanceModule_StormsWail
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.successesinarow=0
		self.soloorgroup_choice=nil
		self.playercount=1
		self.successes=0		
		self.playerdead=false
		self.ringoutdead=false
		self.hitbyseaswell=false
		self.stormswailendtime=0
		self.tidepoolssoaked=0
		self.stormdropdistance=0
		self.arrows={}
		self.angles={}		
		for i=1,7 do
			self.angles[i]={}
		end
		self.clonecounter=0
	end

	--SOURCE: www.programming-idioms.org/idiom/10/shuffle-a-list/.../lua
	local shuffle=function(list)
		local shuffledlist={}
		for i,v in ipairs(list) do
			local pos=math.random(1,#shuffledlist+1)
			table.insert(shuffledlist,pos,v)
		end
		return shuffledlist
	end

	
	function class:PopulateDefaultRaid(environment)	
		self.environment=environment
		
		self.raid:CreatePlayers(environment,0,0,0,1)		
		--self.raid:MakeAllPlayersIrrelevant()
		
		-- for now, no autoattacks.
		for i=1,#self.raid.players do
			self.raid.players[i].combat.autoattackmodule:Cleanup()
			self.raid.players[i].combat.autoattackmodule=nil
		end
	
		--TODO: move raid roles to another function
		self.tanks=self.raid.tanks
		self.currenttankindex=1
		self.rdps=self.raid.rdps
		self.player=self.raid.rdps[1]
		self.raid.players[1].x=0
		self.raid.players[1].y=0				
		
		self.centercircles={}
		
		local gate1=TRAININGGROUNDS_STORMWALLBLOCKADE_WarlockGate.new()
		gate1:Setup(environment)
		gate1.x=0;gate1.y=yard*20
		gate1.groupdancemodule=self
		local gate2=TRAININGGROUNDS_STORMWALLBLOCKADE_WarlockGate.new()
		gate2:Setup(environment)
		gate2.x=0;gate2.y=yard*-20
		--2nd gate is cosmetic
		
		


		
		--TODO: set self.wmcontroller during setup
		self.wmcontroller=self.scenario.wmcontroller
		local wmcontroller=self.wmcontroller
							
		self:SetupInitialCameraFocus()
	end
	
	--TODO: maybe baseline, maybe not
	function class:SetupInitialCameraFocus()
		local camera=self.player.environment.cameramanager.camera
		tinsert(camera.focus,self.player)
		tinsert(camera.focus,{x=0,y=yard*40})
	end

	
	function class:GetIntoInitialPosition()							
		self.player.x=-yard*10
		self.player.y=yard*20
		self.player.currentfacing=math.pi/2	-- facing "north" for 3D camera
	end
	
	function class:StartDancing()
		-- TODO: for some reason we're not using this function when we really should be
	end
	
	function class:StartTestCycle()
	
	

	
		--if(self.firsttechnique)then self:SoakChoiceMessage() end
		
		--TRAININGGROUNDS_FakeDBM_MinorWarning(DBM,"Multi-Sided Strike!")
		
		if(self.soloorgroup_choice==1)then self.playercount=1 else self.playercount=7 end	
		--print("Playercount:",self.playercount)

		--!!!
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		event.time=self.scenario.localtime+0.25	--!!!
		event.execute=function() 
			self:ResetPlayerDeathChecks()										
		end
		tinsert(self.timedevents,event)		
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		event.time=self.scenario.localtime+1
		event.execute=function() 		
			-- ranged
			self:SpawnNearbySeaSwells(5,-yard*15,yard*5,yard*4)
			self:SpawnNearbySeaSwells(5,-yard*15,yard*15,yard*4)
			-- melee
			self:SpawnNearbySeaSwells(5,-yard*15,yard*35,yard*4)
			self:SpawnNearbySeaSwells(5,-yard*5,yard*35,yard*4)
			-- 9 players not grouped for whatever reason
			self:SpawnRandomSeaSwells(9)
			-- player
			self:SpawnNearbySeaSwells(1,self.player.x,self.player.y,yard*0)		
		end
		tinsert(self.timedevents,event)	

 
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		event.time=self.scenario.localtime+1+6
		event.execute=function() 		
			local iconsize="20"
			local icon="\124Tinterface\\icons\\spell_nature_lightningoverload:"..iconsize.."\124t"
			local link="\124cffff0000\124Hspell:285350\124h[Storm's Wail]\124h\124r"			
			local message=icon.."You are affected by "..link.."!"
			TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,1.0,true)

			local aura=self.player.combat:ApplyAuraByClass(TRAININGGROUNDS_STORMWALLBLOCKADE_Aura_StormsWail,self.player.combat)
			aura.expiry=self.player.environment.localtime+13.0
			--self.player.combat:ApplyAuraByClass(TRAININGGROUNDS_JADEFIREMASTERS_Aura_BlueGhost,self.player.combat)
			self.stormswailendtime=self.scenario.localtime+13
			
			local timer=TRAININGGROUNDS_STORMWALLBLOCKADE_Sprite_StormsWailTimer.new()
			timer:Setup(self.environment.game.environment_hud)
			--timer:Setup(self.environment)
			timer.x=-25-50+self.environment.game.SCREEN_WIDTH
			timer.y=-100-25+self.environment.game.SCREEN_HEIGHT
		end
		tinsert(self.timedevents,event)	

		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		event.time=self.scenario.localtime+1+6
		event.execute=function() 		
			if(self.player.y<yard*20)then				
				self:Arrow(self.player.x,self.player.y,yard*-15,yard*5,10,20,0,1,1,1)
				self:Arrow(yard*-15,yard*6,yard*-15,yard*34,10,20,0,1,1,1)
				self:Arrow(yard*-14,yard*35,yard*14,yard*35,10,20,0,1,1,1)
			else
				self:Arrow(self.player.x,self.player.y,yard*0,yard*35,10,20,0,1,1,1)
				self:Arrow(yard*-1,yard*35,yard*-14,yard*35,10,20,0,1,1,1)			
				self:Arrow(yard*-15,yard*33,yard*-15,yard*6,10,20,0,1,1,1)				
			end
		end
		tinsert(self.timedevents,event)		


		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		event.time=self.scenario.localtime+1+6+7
		event.execute=function() 		
			self:ClearArrows()
			if(self.player.y>yard*0)then 
				if(self.mode_choice==1)then
					local message="Time's almost up, run for the warlock portal!"
					TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,4.0,true)
				end
				self:Arrow(self.player.x,self.player.y,yard*0,yard*20,10,20,0,1,1,1)
			end
			self:Arrow(yard*0,yard*18,yard*0,yard*-18,10,20,0,1,1,1)
			self:Arrow(yard*0,yard*-22,yard*0,yard*-38,10,20,0,1,1,1)
		end
		tinsert(self.timedevents,event)			
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		event.time=self.scenario.localtime+1+6+13
		event.execute=function() 	
			self:ClearArrows()
			self.stormdropdistance=(yard*40-self.player.y)/yard
			if(self.stormdropdistance<0)then self.stormdropdistance=0 end
			local storm=TRAININGGROUNDS_STORMWALLBLOCKADE_Decor_EnergizedStorm.new()
			storm:Setup(self.environment)
			storm.x=self.player.x
			storm.y=self.player.y
			storm.currentfacing=math.pi/2	--"north"
		end
		tinsert(self.timedevents,event)			
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		event.time=self.scenario.localtime+1+6+13+3
		event.execute=function()
			TRAININGGROUNDS_FakeDBM_RaidBossEmote("Results:",4.0,true)
		end
		tinsert(self.timedevents,event)			
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		event.time=self.scenario.localtime+1+6+13+5
		event.execute=function()
			local message
			if(self.hitbyseaswell)then
				message="You were hit by Sea Swell."	
			else				
				message="You dodged Sea Swell."	
			end			
			TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,4.0,true)
		end
		tinsert(self.timedevents,event)	
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		event.time=self.scenario.localtime+1+6+13+7
		event.execute=function()
			local message="You cleaned up "
			message=message..tostring(self.tidepoolssoaked).." Freezing Tidepool"
			if(self.tidepoolssoaked==1)then message=message.."." else message=message.."s." end
			TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,4.0,true)
		end
		tinsert(self.timedevents,event)		
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		event.time=self.scenario.localtime+1+6+13+9
		event.execute=function()
			local message="You dropped the Energized Storm "
			local yds=tostring(math.floor(self.stormdropdistance)).." yard"
			if(yds~="1 yard")then yds=yds.."s" end
			message=message..yds.." away."			
			TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,4.0,true)
		end
		tinsert(self.timedevents,event)		
		
		
		
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		event.time=self.scenario.localtime+1+6+13+12
		event.execute=function()
			self.scenario:ShowButtons()
		end
		tinsert(self.timedevents,event)	 
	end
	
	
	function class:ResetPlayerDeathChecks()
		self.successes=0
		self.playerdead=false
		self.ringoutdead=false
		self.stormswailendtime=0
		self.hitbyseaswell=false
		self.tidepoolssoaked=0
		self.stormdropdistance=0
	end
	
	function class:SpawnNearbySeaSwells(count,cx,cy,offset)
		for i=1,count do
			local angle=math.random()*math.pi*2
			local randomoffset=math.random()*offset
			local x=cx+randomoffset*math.cos(angle)
			local y=cy+randomoffset*math.sin(angle)
			local ss=TRAININGGROUNDS_STORMWALLBLOCKADE_Telegraph_SeaSwell.new()
			ss:Setup(self.environment)
			ss.x=x;ss.y=y;ss.groupdancemodule=self
		end
	end
	
	function class:SpawnRandomSeaSwells(count)
		for i=1,count do
			local x=math.random()*yard*30-yard*15
			local y=math.random()*yard*30+yard*5
			local ss=TRAININGGROUNDS_STORMWALLBLOCKADE_Telegraph_SeaSwell.new()
			ss:Setup(self.environment)
			ss.x=x;ss.y=y;ss.groupdancemodule=self
		end	
	end
		
	function class:Arrow(x1,y1,x2,y2,width,radius,R,G,B,A)
		if(self.mode_choice==2)then return nil end
		local testarrow=TRAININGGROUNDS_Telegraph_MovementArrow.new()
		testarrow:Setup(self.environment.game.environment_gameplay)
		--TODO: should testarrow itself have SetArrow which calls drawable:SetArrow?
				-- (in a perfectly encapsulated world, the answer is obviously yes)
		testarrow.drawable:SetColor(R,G,B,A)
		testarrow.drawable:SetArrow(x1,y1,x2,y2,width,radius)
		testarrow.visible=true
		testarrow.drawable.visible=true
		--TRAININGGROUNDS_FrameVisibilityCheck(testarrow.drawable.frame)
		tinsert(self.arrows,testarrow)
		return testarrow
	end
	function class:ClearArrows()
		for i=1,#self.arrows do
			self.arrows[i]:Die()
		end
	end
	
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		
		--print(self.localtime)
		for i=#self.timedevents,1,-1 do
			local event=self.timedevents[i]
			if(self.localtime>=event.time)then	
				event.execute()
				tremove(self.timedevents,i)
			end
		end
		
		--TODO: super.step (step is not currently baseline)
		if(self.player)then
			if(self.player.y<-yard*40)then
				self.player.y=-yard*40
			end
			if(not self.ringoutdead)then			
				local limit
				if(self.player.y>0)then limit=yard*20 else limit=yard*20*0.75 end
				if(math.abs(self.player.x)>limit or self.player.y>yard*40)then
					self.ringoutdead=true
					self.playerdead=true
					self.player.combat:FlashDamageFlash_Alert()
					local message="You fell into the water!"
					TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,2.0,true)
				end				
			end
			
		end			
	end
		
	function class:ReactToCustomDanceEvent(event)
		-- mobile_fakemonkboss doesn't check whether it's hitting primary player, so check now
		if(event.source~=self.raid.players[1].combat)then return end
		
		--TODO: maybe this should be global (but we'd have to call it "TRAININGGROUNDS_yard" instead)
		local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)		
	
		-- local targetcombat=event.target
		-- local targetmobile=nil
		-- if(targetcombat)then targetmobile=targetcombat.owner end
		-- local camera=self.multisidedstrike.environment.cameramanager.camera
		
		if(event.action==TRAININGGROUNDS_STORMWALLBLOCKADE_CustomDanceEventType.SEASWELL)then
			self.player.combat:FlashDamageFlash_Alert()
			self.playerisdead=true
			self.hitbyseaswell=true
		elseif(event.action==TRAININGGROUNDS_STORMWALLBLOCKADE_CustomDanceEventType.SOAK_TIDEPOOL)then
			self.tidepoolssoaked=self.tidepoolssoaked+1			
		end
	end

	
	
	function class:GetEndOfCycleDelay()
		return 3.0
	end
	
	--TODO: cleanup (and cleanup on base groupdancemodule too?)
	function class:Cleanup()
		--TODO: NYI
	end
end
