

do

	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
	local REDX="\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_7:12\124t"
	local INTRO_TIME_MULTIPLIER=1.0

	TRAININGGROUNDS_UUNAT_CustomDanceEventType={}
	local i=0
	i=i+1;TRAININGGROUNDS_UUNAT_CustomDanceEventType.SUCCESS=i
	i=i+1;TRAININGGROUNDS_UUNAT_CustomDanceEventType.HIT_BY_PIERCING=i

	
	local super=TRAININGGROUNDS_GroupDanceModule	
	TRAININGGROUNDS_UUNAT_GroupDanceModule_Uunat=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_UUNAT_GroupDanceModule_Uunat
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.mode_choice=nil
		self.playerisdead=false
		self.lastpiercetime=0
		self.piercestacks=0
		self.pierceduration=0
		self.resultsmessage=nil
	end


	
	function class:PopulateDefaultRaid(environment)	
		self.environment=environment

		self.miniboss=self.bosscontroller.Uunat	
	
		self.raid:CreatePlayers(environment,0,0,0,1)		
		--self.raid:MakeAllPlayersIrrelevant()
		
		-- for now, no autoattacks.
		for i=1,#self.raid.players do
			self.raid.players[i].combat.autoattackmodule:Cleanup()
			self.raid.players[i].combat.autoattackmodule=nil
		end
	
		--TODO: move raid roles to another function
		self.tanks=self.raid.tanks
		self.currenttankindex=1
		self.rdps=self.raid.rdps
		self.player=self.raid.rdps[1]
		--self.raid.players[1].currentfacing=math.pi
		--self.raid.players[1].currentfacing_3D=self.raid.players[1].currentfacing
		
		self.centercircles={}
		
		 self.skybox=TRAININGGROUNDS_UUNAT_Decor_Skybox.new()
		 self.skybox:Setup(environment)
		self.floor=TRAININGGROUNDS_UUNAT_Decor_Floor.new()
		self.floor:Setup(environment)		
		self.floorsize=0.6 --1 --0.2
		--self.floorsize=0.2
		self.floor.drawable.scale3D=self.floorsize*1.1*1	--TODO: probably move to modelinfo		
		-- Giving up on "obscurity" for now, it's interfering with things in the background (draw order)		
		--self.obscurity.drawable.scale3D=self.floorsize*1.65*1.1	--TODO: probably move to modelinfo
		
		local icon=TRAININGGROUNDS_UUNAT_Sprite_PiercingGaze.new()
		icon:Setup(self.environment.game.environment_hud)
		--timer:Setup(self.environment)
		icon.x=-25-50+self.environment.game.SCREEN_WIDTH
		icon.y=-100-25+self.environment.game.SCREEN_HEIGHT		
		icon.groupdancemodule=self
		

		-- test=TRAININGGROUNDS_UUNAT_Decor_PiercingGaze_Beam.new()
		-- test:Setup(environment)		
		-- test.currentfacing_3D=0
		-- test.x=yard*10
		-- test=TRAININGGROUNDS_UUNAT_Decor_PiercingGaze_Beam.new()
		-- test:Setup(environment)		
		-- test.currentfacing_3D=math.pi/2;test.targetfacing_3D=math.pi/2;test.currentfacing=math.pi/2
		-- test.x=yard*10

		
		--TODO: set self.wmcontroller during setup
		self.wmcontroller=self.scenario.wmcontroller
		local wmcontroller=self.wmcontroller
							
		self:SetupInitialCameraFocus()
	end
	
	--TODO: maybe baseline, maybe not
	function class:SetupInitialCameraFocus()
		local camera=self.player.environment.cameramanager.camera
		tinsert(camera.focus,self.player)
	end

	
	function class:GetIntoInitialPosition()							
		self.player.x=0
		self.player.y=-yard*0
		self.player.currentfacing=math.pi/2	-- facing "north" for 3D camera
		self.player.currentfacing_3D=self.player.currentfacing
		self.player.targetfacing_3D=self.player.currentfacing
		self.scenario.environment.game.environment_gameplay.cameramanager.camera.cangy=self.player.currentfacing
		
	end
	
	function class:StartDancing()
		-- TODO: for some reason we're not using this function when we really should be
	end
	
	function class:StartTestCycle()
		if(self.mode_choice==1)then
			self:Start_Mode1()
		elseif(self.mode_choice==2)then
			--TODO:
		elseif(self.mode_choice==3)then
			--TODO:
		end
	end
	
	function class:Start_Mode1() 	-- "mode one", not "model"
		--if(self.firsttechnique)then self:SoakChoiceMessage() end
		
		if(self.soloorgroup_choice==1)then self.playercount=1 else self.playercount=7 end	
		--print("Playercount:",self.playercount)
		self:ResetPlayerDeathChecks()
		
		--self:SpawnFlames()	--!!!
		
		local totaltime=0
		--!!!
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+0.25
		event.time=self.scenario.localtime+totaltime	
		event.execute=function() 		
			self:SpawnEyebeams()
		end
		tinsert(self.timedevents,event)	
		
		

		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+27
		event.time=self.scenario.localtime+totaltime
		event.execute=function() 		
			local message
			if(self.playerisdead)then
				self.successesinarow=0
				message="Try again..."
			else				
				message="OK!"
			end
			TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,2.0,false)
		end
		tinsert(self.timedevents,event)					

		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		--totaltime=totaltime+2
		totaltime=totaltime+2
		event.time=self.scenario.localtime+totaltime
		event.execute=function() 				
			self.scenario:ShowButtons()
		end
		tinsert(self.timedevents,event)			
	end
	
	
	
	function class:SpawnEyebeams()
		self.eyes={}
		self.beams={}
		local angle1=math.random()*math.pi*2
						--angle1=0	--!!!
		local anglediff=math.pi/2
		if(math.random()>0.5)then anglediff=-anglediff end				
		---------------------"strafing" eyes-------------
		-- -- now determine the placement of the other eye
		-- -- +/- 1/4th circle in either direction, with slight variance
		-- -- up to 1/8th of a circle in either direction
		-- local anglevariance=(math.pi/4)
		-- -- modifier ranges from 0-1, strong bias towards 0
		-- local modifier=1-math.pow(math.random()*1,0.25)
		-- anglevariance=anglevariance*modifier
		-- if(math.random()>0.5)then anglevariance=-anglevariance end				
		--------------------"rotating" eyes--------------
		local anglevariance=0
			
		local angle2=angle1+anglediff+anglevariance



		
--print("angles:",angle1,angle2,modifier,anglevariance)
		self:SpawnEyeAndBeam(angle1)
		self:SpawnEyeAndBeam(angle2)
	end
	
	function class:SpawnEyeAndBeam(angle)
		local sweepmodifier=1
		if(math.random()>0.5) then sweepmodifier=-1 end

		local eye=TRAININGGROUNDS_UUNAT_Decor_PiercingGaze_Eye.new()
		self:SetupEyeOrBeam(eye,angle,sweepmodifier,0,yard*25)
		tinsert(self.eyes,eye)	
		eye.targetplayer=self.player
		eye.groupdancemodule=self
		eye.beamangle=angle+math.pi
		local beam=TRAININGGROUNDS_UUNAT_Decor_PiercingGaze_Beam.new()
		self:SetupEyeOrBeam(beam,angle,sweepmodifier,1,0)		
		tinsert(self.beams,beam)	
		eye.beam=beam
		--self.temp=beam
		--print("Beam:",beam.x,beam.y,beam.xspeed)
	end
	function class:SetupEyeOrBeam(obj,angle,sweepmodifier,opposite,extradist)
		local EYEDISTANCE=yard*100
		local SWEEPDISTANCE=yard*90
		-- local EYESPEED=yard*7			
		-- -- extradist is used to position the eye behind the beam
		-- local totaldist=EYEDISTANCE+extradist
		-- --"angle" is the direction the eye is placed, OPPOSITE of the direction the eye is facing
		-- --"sweepangle" is the direction the eye is moving (perpendicular to "angle")
		-- local sweepangle=angle+math.pi/2*sweepmodifier
		-- local sweepoffsetx=SWEEPDISTANCE*-math.cos(sweepangle)
		-- local sweepoffsety=SWEEPDISTANCE*-math.sin(sweepangle)
		-- obj:Setup(self.environment)
		-- -- eye starts out in "the corner" (move away from facing, then move 1/2 away from sweep direction)
		-- obj.x=totaldist*math.cos(angle)+sweepoffsetx;obj.y=totaldist*math.sin(angle)+sweepoffsety;obj.z=yard*0
		-- local facing=angle+math.pi
		-- if(opposite==1)then facing=facing-math.pi end
		-- obj.currentfacing=facing;obj.currentfacing_3D=facing;obj.targetfacing_3D=facing
		-- obj.xspeed=EYESPEED*math.cos(sweepangle);obj.yspeed=EYESPEED*math.sin(sweepangle)
		-- obj.currentfacing=facing;obj.currentfacing_3D=facing;obj.targetfacing_3D=facing
	
		local TURNSPEED=0.02
		-- extradist is used to position the eye behind the beam
		local totaldist=EYEDISTANCE+extradist
		--"angle" is the direction the eye is placed, OPPOSITE of the direction the eye is facing
		obj:Setup(self.environment)		
		obj.x=totaldist*math.cos(angle);obj.y=totaldist*math.sin(angle);obj.z=yard*0
		local facing=angle+math.pi
		if(opposite==1)then facing=facing-math.pi end
		--sweepmodifier is the direction eye turns
		obj.currentfacing=facing-sweepmodifier*math.pi/4;obj.currentfacing_3D=facing-sweepmodifier*math.pi/4;obj.targetfacing_3D=facing-sweepmodifier*math.pi/4
		obj.turndirection=sweepmodifier
		--obj.turnspeed=TURNSPEED
	end
	
	
	function class:ResetPlayerDeathChecks()
		self.playerisdead=false
		self.resultsmessage=nil
		self.lastpiercetime=0
		self.piercestacks=0
		self.pierceduration=0	
	end
	
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		
		--print("Player:",self.raid.players[1].y)
		--if(self.temp)then	print("Beam:",self.temp.y) end		
		self.pierceduration=self.pierceduration-elapsed
		if(self.pierceduration<=0)then
			self.pierceduration=0
			self.piercestacks=0
		end
		
		for i=#self.timedevents,1,-1 do
			local event=self.timedevents[i]
			if(self.localtime>=event.time)then	
				event.execute()
				tremove(self.timedevents,i)
			end
		end
	end
		
	function class:ReactToCustomDanceEvent(event)
		-- mobile_fakemonkboss doesn't check whether it's hitting primary player, so check now
		if(event.source~=self.raid.players[1].combat)then return end
		
		--TODO: maybe this should be global (but we'd have to call it "TRAININGGROUNDS_yard" instead)
		local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)		
	
		-- local targetcombat=event.target
		-- local targetmobile=nil
		-- if(targetcombat)then targetmobile=targetcombat.owner end
		-- local camera=self.multisidedstrike.environment.cameramanager.camera
		
		if(event.action==TRAININGGROUNDS_UUNAT_CustomDanceEventType.HIT_BY_PIERCING)then
			
			--print("Hit",self.environment.localtime)
			local piercetime=self.environment.localtime
			--print("Time since last:",piercetime-self.lastpiercetime)
			--if(piercetime-self.lastpiercetime>1.0)then
			if(true)then
				self.player.combat:FlashDamageFlash_Alert()
				self.piercestacks=self.piercestacks+1
				self.pierceduration=self.pierceduration+4.0
			end			
			if(self.piercestacks>1)then
				if(not self.resultsmessage)then
					--local message="Hit by double Piercing Gaze!"
					--TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,2.0,true)
					--self.resultsmessage=REDX.." Piercing Gaze is typically unavoidable, but do your best to avoid taking two hits within 4 seconds."
				end
				
				self.playerisdead=true
			end

			self.lastpiercetime=piercetime
		else

		end
	end


	

	
	function class:GetEndOfCycleDelay()
		return 3.0
	end
	
	--TODO: cleanup (and cleanup on base groupdancemodule too?)
	function class:Cleanup()
		--TODO: NYI
	end
end
