

do
	local super=TRAININGGROUNDS_Scenario
	TRAININGGROUNDS_JADEFIREMASTERS_Scenario_MultiSidedStrike = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JADEFIREMASTERS_Scenario_MultiSidedStrike

	function class:Populate()

		--self.environment.game.window.background.texture:SetColorTexture(0,0,0,0.0)
		
		super.Populate(self)				
			
		self:CreateBossController()
		
		local currentplayer=self.raid.rdps[1]
		self.controls:SetPlayer(currentplayer)
		currentplayer:SetPlayerAppearance()
		local relevant=TRAININGGROUNDS_Aura_PlayerControlled.new()
		relevant:Setup(currentplayer.combat,currentplayer.combat,currentplayer:GetLocalTime())			

		self.multisidedstrike.groupdancemodule:GetIntoInitialPosition()
		

		
		
		self.startbuttons={}
		--!!!
		local startbutton	
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2-125
		startbutton.y=self.environment.game.window.frame:GetHeight()/2-200
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Solo")
		startbutton.drawable.frame:SetScript("OnClick",function()
					self.multisidedstrike.groupdancemodule.soloorgroup_choice=1
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)

		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2+125
		startbutton.y=self.environment.game.window.frame:GetHeight()/2-200
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Group")
		startbutton.drawable.frame:SetScript("OnClick",function()
					self.multisidedstrike.groupdancemodule.soloorgroup_choice=2
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)
	end

	function class:SetCamera()
		self.environment.game.environment_gameplay.cameramanager.camera=TRAININGGROUNDS_Camera3D.new()
		--self.environment.game.environment_gameplay.cameramanager.camera:Setup(self.environment)
		self.environment.game.environment_gameplay.cameramanager.camera:Setup(self.environment.game.environment_gameplay)
	end	

	--TODO: somehow connect camera+playercontrols, since they're usually codependent
	function class:CreatePlayerControls()
		local controls = TRAININGGROUNDS_ScenarioPlayerControls_CharacterMode_3D.new()
		controls:Setup(self.environment,self)			
		self.controls=controls
	end
	
	function class:CreateBossController()
		self.multisidedstrike=TRAININGGROUNDS_JADEFIREMASTERS_BossController_MultiSidedStrike.new()
		--TODO: at this point it becomes very awkward that scenario.environment is not scenario.environment_gameplay
		self.multisidedstrike:Setup(self.environment.game.environment_gameplay,self)
		self.multisidedstrike:CreateBoss()		
		self.multisidedstrike.groupdancemodule.bosscontroller=self.multisidedstrike
		self.multisidedstrike.groupdancemodule:PopulateDefaultRaid(self.environment.game.environment_gameplay)
	end
	
	function class:OnStartButton()
		for i=1,#self.startbuttons do
			self.startbuttons[i].visible=false	
			self.startbuttons[i].drawable.frame:EnableMouse(false)
		end
		self.multisidedstrike.groupdancemodule:StartTestCycle()
	end
	
	function class:ShowButtons()
		for i=1,#self.startbuttons do
			self.startbuttons[i].visible=true	
			self.startbuttons[i].drawable.frame:EnableMouse(true)
		end	
	end

	function class:Step(elapsed)
		super.Step(self,elapsed)
		if(self.controls and self.controls.player)then
			self.controls.player.currentfacing=self.controls.player.currentfacing_3D
			self.controls.player.targetfacing_3D=self.controls.player.currentfacing_3D
			self.controls.player.x=0
			self.controls.player.y=0
			self.controls.player.z=0
			self.controls.player.backpedalspeed=0
			self.controls.player.basemovespeed=0
			
		end
	end
	
	function class:OnEscapeKey()
		--TODO: "DefaultColorTexture" or something
		--self.environment.game.window.background.texture:SetColorTexture(0,0,0,0.5)
		self.environment.game:LoadScenarioByClass(TRAININGGROUNDS_Scenario_Menu)
	end
	
	

	
	
end
