
do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_JADEFIREMASTERS_Drawable_SpawnFlash_Blue=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JADEFIREMASTERS_Drawable_SpawnFlash_Blue
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false

		self.modelfilename="spells/Provinggrounds_coalesce_impact_blue.m2"				
		self.scale3D=0.5	--TODO: probably move to modelinfo
		self.positionmultiplier=0.95	--TODO: move to modelinfo
		self.zsortoffset3D=-0.5	--measured in yards.  TODO: move to modelinfo
		--self.defaultanimation=0
		self.defaultanimation=127
	end
end

do
	local super=TRAININGGROUNDS_JADEFIREMASTERS_Drawable_SpawnFlash_Blue
	TRAININGGROUNDS_JADEFIREMASTERS_Drawable_SpawnFlash_Green=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JADEFIREMASTERS_Drawable_SpawnFlash_Green
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.modelfilename="spells/Provinggrounds_coalesce_impact_green.m2"		
	end
end

do
	local super=TRAININGGROUNDS_JADEFIREMASTERS_Drawable_SpawnFlash_Blue
	TRAININGGROUNDS_JADEFIREMASTERS_Drawable_SpawnFlash_Red=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JADEFIREMASTERS_Drawable_SpawnFlash_Red
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.modelfilename="spells/Provinggrounds_coalesce_impact_red.m2"		
	end
end


-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_JADEFIREMASTERS_Decor_SpawnFlash=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JADEFIREMASTERS_Decor_SpawnFlash

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.currentanim=0
	end
	
	function class:SetDrawable()
		-- set clonecounter BEFORE calling setup!
		if(self.clonecounter==1 or self.clonecounter==5)then
			self.drawable=TRAININGGROUNDS_JADEFIREMASTERS_Drawable_SpawnFlash_Blue.new()
		elseif(self.clonecounter==2 or self.clonecounter==4)then
			self.drawable=TRAININGGROUNDS_JADEFIREMASTERS_Drawable_SpawnFlash_Green.new()
		else
			self.drawable=TRAININGGROUNDS_JADEFIREMASTERS_Drawable_SpawnFlash_Red.new()
		end
		self.drawable:Setup(self,self.environment)
		--self.drawable.frame:SetAnimation(2)
	end
	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.telegraphframelayer
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		if(self.alivetime==0)then
			--self.drawable.frame:SetAnimation(127)
		elseif(self.alivetime>1.0)then
			self:Die()
		end
		--TODO: add BEFORE checking time (but requires better state machine check)
		self.alivetime=self.alivetime+elapsed
	end
	
	-- function class:Step()
		-- --!!!
		-- --self.drawable.frame:FreezeAnimation(2,.1500)
		
	-- end	
end