do

	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
	local REDX="\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_7:12\124t"
	local INTRO_TIME_MULTIPLIER=1.0

	TRAININGGROUNDS_JAINA_CustomDanceEventType={}
	local i=0
	i=i+1;TRAININGGROUNDS_JAINA_CustomDanceEventType.SUCCESS=i
	i=i+1;TRAININGGROUNDS_JAINA_CustomDanceEventType.HIT_BY_SHATTERINGLANCE=i
	i=i+1;TRAININGGROUNDS_JAINA_CustomDanceEventType.HIT_BY_BROADSIDE=i
	i=i+1;TRAININGGROUNDS_JAINA_CustomDanceEventType.HIT_BY_CRYSTALLINEDUST=i
	i=i+1;TRAININGGROUNDS_JAINA_CustomDanceEventType.HIT_BY_GLACIALRAY=i
	i=i+1;TRAININGGROUNDS_JAINA_CustomDanceEventType.HIT_BY_ICEFALL=i

	
	local super=TRAININGGROUNDS_GroupDanceModule	
	TRAININGGROUNDS_JAINA_GroupDanceModule_Jaina=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JAINA_GroupDanceModule_Jaina
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.successesinarow=0
		self.mode_choice=nil
		--self.cast_time=4.0
		--self.channel_time=6.5
		--self.total_ticks=12
		-- self.spin_per_tick=math.pi*2/12
		-- self.conewidth=math.pi*2/6
		-- self.flamecount=1
		--self.turnspeed=2.0
		self.playerisdead=false
		self.shatteringlancehits=0
		self.arrows={}
	end


	
	function class:PopulateDefaultRaid(environment)	
		self.environment=environment

		self.jaina=self.bosscontroller.jaina	
		self.jaina.groupdancemodule=self
	
		self.raid:CreatePlayers(environment,0,0,0,1)		
		--self.raid:MakeAllPlayersIrrelevant()
		
		-- for now, no autoattacks.
		for i=1,#self.raid.players do
			self.raid.players[i].combat.autoattackmodule:Cleanup()
			self.raid.players[i].combat.autoattackmodule=nil
		end
	
		--TODO: move raid roles to another function
		self.tanks=self.raid.tanks
		self.currenttankindex=1
		self.rdps=self.raid.rdps
		self.player=self.raid.rdps[1]

		
		self.centercircles={}
		
		
		-- self.floor=TRAININGGROUNDS_JAINA_Decor_Floor.new()
		-- self.floor:Setup(environment)

		
		local platformsize=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(100)		
		--TODO: arenaborder should be in baseline scenario class
		local bigcircle=TRAININGGROUNDS_BigCircle.new()
		bigcircle:Setup(self.environment.game.environment_gameplay)
		bigcircle.drawable.width=platformsize+20
		bigcircle.drawable.height=platformsize+20
		bigcircle.x=0
		bigcircle.y=0
		bigcircle.drawable:SetColor(.5,.75,1,1)		
		local bigcircle=TRAININGGROUNDS_BigCircle.new()
		bigcircle:Setup(self.environment.game.environment_gameplay)
		bigcircle.drawable.width=platformsize
		bigcircle.drawable.height=platformsize
		bigcircle.x=0
		bigcircle.y=0	
		bigcircle.drawable:SetColor(.375,.625,1,1)
		
		
		local chillicon=TRAININGGROUNDS_JAINA_Sprite_ChillingTouch.new()
		chillicon:Setup(self.environment.game.environment_hud)
		--timer:Setup(self.environment)
		chillicon.x=-25-50+self.environment.game.SCREEN_WIDTH
		chillicon.y=-100-25+self.environment.game.SCREEN_HEIGHT		
		chillicon.groupdancemodule=self

		
		--TODO: set self.wmcontroller during setup
		self.wmcontroller=self.scenario.wmcontroller
		local wmcontroller=self.wmcontroller
							
		self:SetupInitialCameraFocus()
	end
	
	--TODO: maybe baseline, maybe not
	function class:SetupInitialCameraFocus()
		local camera=self.player.environment.cameramanager.camera
		tinsert(camera.focus,self.player)
	end

	
	function class:GetIntoInitialPosition()							
		self.jaina.x=yard*0
		self.jaina.y=yard*40
	
		
		self.player.x=0
		self.player.y=yard*27
		--self.player.y=0--!!!
		self.player.currentfacing=math.pi/2	-- facing "north" for 3D camera
		--self.player.currentfacing_3D=self.player.currentfacing
		--self.player.targetfacing_3D=self.player.currentfacing
		self.scenario.environment.game.environment_gameplay.cameramanager.camera.cangy=self.player.currentfacing

		-- --!!!
		-- self.floor.x=self.player.x
		-- self.floor.y=self.player.y
		-- self.scenario.TEMPfloor=self.floor
		self.scenario.player=self.player
		self.player.groupdancemodule=self
		
		

		
	end
	
	function class:StartDancing()
		-- TODO: for some reason we're not using this function when we really should be
	end
	
	function class:StartTestCycle()
		self:ResetAurasAndIceblocks()
		self:ResetPlayerDeathChecks()
		self:ResetMassSelfFreeze()
		self.player.combat:ApplyAuraByClass(TRAININGGROUNDS_JAINA_Aura_FrozenSeas,self.player.combat)
		local chill=self.player.combat:ApplyAuraByClass(TRAININGGROUNDS_JAINA_Aura_ChillingTouch,self.player.combat)
		-- set initial stacks between 4-6 at random
		chill.groupdancemodule=self
		chill.intensity=4+math.floor(math.random()*3)
		

		
		
		-- local bosstitlebar=TRAININGGROUNDS_BossTitleBar.new()
		-- bosstitlebar:Setup(self.scenario.environment.game.environment_hud)
		-- bosstitlebar:SetText("Lady Jaina Proudmoore")
		-- bosstitlebar.x=self.environment.game.SCREEN_WIDTH/2
		-- bosstitlebar.y=self.environment.game.SCREEN_HEIGHT-70
		-- bosstitlebar.drawable.width=1000;bosstitlebar.drawable.height=60
	
		local totaltime=0
		local BASE_TIME=-10.0
		--BASE_TIME=-48.0 -- raidfreeze test
		--BASE_TIME=-(60.0+19.0)	-- first icefall test
		--BASE_TIME=-(60.0+57.0)	-- siegebreaker blast test
		--BASE_TIME=-(120.0+9.0)	-- double icefall test
		--BASE_TIME=-(120.0+44.0) -- double glacialray test
	
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+11.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								TEMP_CastSpellOnTargetMobile(self.jaina,TRAININGGROUNDS_JAINA_Spell_OrbOfFrost,nil)
							end;tinsert(self.timedevents,event)	
		end

		--TODO: jaina face outside
						
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+18.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 						
							local broadside=TEMP_CastSpellOnTargetMobile(self.jaina,TRAININGGROUNDS_JAINA_Spell_Broadside,nil)
							broadside.groupdancemodule=self
						end;tinsert(self.timedevents,event)	
		end			

		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+23.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								TEMP_CastSpellOnTargetMobile(self.jaina,TRAININGGROUNDS_JAINA_Spell_PrismaticImage,nil)
							end;tinsert(self.timedevents,event)		
		end					

		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+26.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								TEMP_CastSpellOnTargetMobile(self.jaina,TRAININGGROUNDS_JAINA_Spell_CrystallineDust,nil)
							end;tinsert(self.timedevents,event)								
		end				
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+28.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								self.prismaticimage=TRAININGGROUNDS_JAINA_PrismaticImage_ApplyPrismaticImage(self)
							end;tinsert(self.timedevents,event)								
		end				
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+37.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								self:MainTankFreeze()
							end;tinsert(self.timedevents,event)				
		end

		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+49.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 														
								TEMP_CastSpellOnTargetMobile(self.jaina,TRAININGGROUNDS_JAINA_Spell_GlacialRay,nil)
								self:GlacialRayEmote()
							end;tinsert(self.timedevents,event)				
		end
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+49.5
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 																						
								self:GlacialRayArrows()
							end;tinsert(self.timedevents,event)				
		end		
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+52.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								local tw=TRAININGGROUNDS_JAINA_Decor_TimeWarp.new()
								tw:Setup(self.environment)
								tw.owner=self.player
							end;tinsert(self.timedevents,event)				
		end		

		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+54
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								self:KeepDodgingEmote()
							end;tinsert(self.timedevents,event)				
		end				

		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+57.5
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								local ib=TRAININGGROUNDS_JAINA_Decor_JainaIceBlock.new()
								ib:Setup(self.environment)
								ib.x=self.jaina.x;ib.y=self.jaina.y-1
								self:NowFreezeEmote()
								self:InverseGlacialRayArrow()
							end;tinsert(self.timedevents,event)				
		end				

		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+58
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								--setup raid freeze
								local jaina=self.jaina
								local angle=self.freezeangle
								local dist=math.sqrt(jaina.x*jaina.x+jaina.y*jaina.y)								
								for i=1,5 do
									-- 5 players near Jaina, towards center
									local xbase=jaina.x
									local ybase=jaina.y
									local anglemodifier=math.random()*math.pi/8-math.pi/16
									-- freeze between 2-5 yards away
									local x=xbase+math.cos(angle+anglemodifier)*yard*(2+math.random()*4)
									local y=ybase+math.sin(angle+anglemodifier)*yard*(2+math.random()*4)
									local duration=4.0+3.0*math.random()
									--8 seconds to get from 12->20 stacks, then another 1-4 seconds to drop below 80% HP
									local freezetimemodifier=8.0+1.0+math.random()*4.0
									local freezetime=self.scenario.localtime+freezetimemodifier
									local event2=TRAININGGROUNDS_TimedDanceEvent.new()
									event2.time=freezetime
									event2.execute=function() 		
										self:ApplyIceblockAndLances(x,y,duration)
									end;tinsert(self.timedevents,event2)
									--print("Queued iceblock for",event2.time,"-- current time is",self.scenario.localtime)

								end
								
							end;tinsert(self.timedevents,event)				
		end		

		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+73.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								self:RunAwayEmote()
							end;tinsert(self.timedevents,event)				
		end				

		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+60.0+20.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								TEMP_CastSpellOnTargetMobile(self.jaina,TRAININGGROUNDS_JAINA_Spell_Icefall,nil)
							end;tinsert(self.timedevents,event)				
		end		

		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+60.0+22.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								TEMP_CastSpellOnTargetMobile(self.jaina,TRAININGGROUNDS_JAINA_Spell_PrismaticImage,nil)
							end;tinsert(self.timedevents,event)	
		end	

		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+60.0+24.0	--moved from 23 to 24 due to queue concerns
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 						
							local broadside=TEMP_CastSpellOnTargetMobile(self.jaina,TRAININGGROUNDS_JAINA_Spell_Broadside,nil)
							broadside.groupdancemodule=self
						end;tinsert(self.timedevents,event)	
		end	
		

		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+60.0+26.0	--moved from 24 to 26 due to queue concerns
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								TEMP_CastSpellOnTargetMobile(self.jaina,TRAININGGROUNDS_JAINA_Spell_CrystallineDust,nil)
							end;tinsert(self.timedevents,event)								
		end	
				
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+60.0+27.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								self.prismaticimage=TRAININGGROUNDS_JAINA_PrismaticImage_ApplyPrismaticImage(self)
							end;tinsert(self.timedevents,event)								
		end								

		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+60.0+40.0	--moved from 24 to 26 due to queue concerns
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								TEMP_CastSpellOnTargetMobile(self.jaina,TRAININGGROUNDS_JAINA_Spell_CrystallineDust,nil)
							end;tinsert(self.timedevents,event)								
		end	
				
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+60.0+50.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 													
								TEMP_CastSpellOnTargetMobile(self.jaina,TRAININGGROUNDS_JAINA_Spell_GlacialRay,nil)
								self:GlacialRayEmote()							
							end;tinsert(self.timedevents,event)				
		end		
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+60.0+50.5
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 																						
								self:GlacialRayArrows()
							end;tinsert(self.timedevents,event)				
		end				
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+120.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 						
							local broadside=TEMP_CastSpellOnTargetMobile(self.jaina,TRAININGGROUNDS_JAINA_Spell_SiegebreakerBlast,nil)
							broadside.groupdancemodule=self
						end;tinsert(self.timedevents,event)	
		end			


		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+120+2.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								TEMP_CastSpellOnTargetMobile(self.jaina,TRAININGGROUNDS_JAINA_Spell_CrystallineDust,nil)
							end;tinsert(self.timedevents,event)								
		end				

		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+120.0+2.5
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								self:MainTankFreeze()
							end;tinsert(self.timedevents,event)				
		end
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+120.0+4.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								TEMP_CastSpellOnTargetMobile(self.jaina,TRAININGGROUNDS_JAINA_Spell_PrismaticImage,nil)
							end;tinsert(self.timedevents,event)	
		end			
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+120.0+9.0	--moved from 23 to 24 due to queue concerns
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 						
							local broadside=TEMP_CastSpellOnTargetMobile(self.jaina,TRAININGGROUNDS_JAINA_Spell_Broadside,nil)
							broadside.groupdancemodule=self
						end;tinsert(self.timedevents,event)	
		end			
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+120.0+9.5
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								self.prismaticimage=TRAININGGROUNDS_JAINA_PrismaticImage_ApplyPrismaticImage(self)
							end;tinsert(self.timedevents,event)								
		end			
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+120.0+13.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								TEMP_CastSpellOnTargetMobile(self.jaina,TRAININGGROUNDS_JAINA_Spell_OrbOfFrost,nil)
							end;tinsert(self.timedevents,event)								
		end				
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+120+20.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								TEMP_CastSpellOnTargetMobile(self.jaina,TRAININGGROUNDS_JAINA_Spell_CrystallineDust,nil)
							end;tinsert(self.timedevents,event)								
		end			
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+120.0+20.5
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								self:MainTankFreeze()
							end;tinsert(self.timedevents,event)				
		end		
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+120.0+22.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								TEMP_CastSpellOnTargetMobile(self.jaina,TRAININGGROUNDS_JAINA_Spell_Icefall,nil)
							end;tinsert(self.timedevents,event)
		end
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+120.0+40.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								TEMP_CastSpellOnTargetMobile(self.jaina,TRAININGGROUNDS_JAINA_Spell_PrismaticImage,nil)
							end;tinsert(self.timedevents,event)	
		end				
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+120.0+45.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								self.prismaticimage=TRAININGGROUNDS_JAINA_PrismaticImage_ApplyPrismaticImage(self)
							end;tinsert(self.timedevents,event)								
		end			
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+120.0+51.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 							
								self:GlacialRayEmote()
								self.prismaticimage.groupdancemodule=self
								TEMP_CastSpellOnTargetMobile(self.jaina,TRAININGGROUNDS_JAINA_Spell_GlacialRay,nil)
								TEMP_CastSpellOnTargetMobile(self.prismaticimage,TRAININGGROUNDS_JAINA_Spell_GlacialRay,nil)
							end;tinsert(self.timedevents,event)				
		end			
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=BASE_TIME+180.0+3.0+3.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 		
				--print("Looking for Frozen Seas aura...")
				local auras=self.player.combat.auramodule:GetAurasByClassIfExist(TRAININGGROUNDS_JAINA_Aura_FrozenSeas)			
				--print("#auras:",#auras)
				for i=1,#auras do
					--print("Killing Frozen Seas aura")
					auras[i]:Die()
				end			
				self:ResetAurasAndIceblocks()
				self.scenario:ShowButtons()
			end
			tinsert(self.timedevents,event)
		end				

		
		-- local event=TRAININGGROUNDS_TimedDanceEvent.new()
		-- totaltime=totaltime+1.
		-- event.time=self.scenario.localtime+totaltime
		-- event.execute=function() 		
			-- self.jaina.drawable:SetAnimation(TRAININGGROUNDS_JAINA_ANIMATION_LIST.Stand)		
		-- end
		-- tinsert(self.timedevents,event)	

		-- local event=TRAININGGROUNDS_TimedDanceEvent.new()
		-- totaltime=totaltime+1
		-- event.time=self.scenario.localtime+totaltime
		-- event.execute=function() 		
			-- local message
			-- if(self.playerisdead)then
				-- self.successesinarow=0
				-- message="Try again..."
			-- else
				-- self.successesinarow=self.successesinarow+1
				-- message="OK!"
			-- end
			-- TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,2.0,false)
		-- end
		-- tinsert(self.timedevents,event)					

		-- local event=TRAININGGROUNDS_TimedDanceEvent.new()
		-- totaltime=totaltime+1
		-- event.time=self.scenario.localtime+totaltime
		-- event.execute=function() 		
			-- if(	self.successesinarow>1)then
				-- local message="("..tostring(self.successesinarow).." in a row)"
				-- TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,1.0,false)
			-- end			
		-- end
		-- tinsert(self.timedevents,event)							


	end
	
	
	function class:ResetAurasAndIceblocks()
		local auras=self.player.combat.auramodule:GetAurasByClassIfExist(TRAININGGROUNDS_JAINA_Aura_ChillingTouch)
		for i=1,#auras do
			auras[i]:Die()
		end
		local auras=self.player.combat.auramodule:GetAurasByClassIfExist(TRAININGGROUNDS_JAINA_Aura_FrozenSolid)
		for i=1,#auras do
			auras[i]:Die()
		end		
		self.player.combat.auramodule.newauras={}
		--self.player.combat.auramodule:DEBUG_DispelEntireAuraList(self.player.combat.auramodule.allauras)
		--TODO: remove iceblocks too
	end
	
	
	function class:ResetPlayerDeathChecks()
		self.playerisdead=false
		self.shatteringlancehits=0
	end
	
	function class:ResetMassSelfFreeze()
		self.freezeangle=nil
		self.freezetimers={}		
	end
	
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		
		--print(self.localtime)
		for i=#self.timedevents,1,-1 do
			local event=self.timedevents[i]
			if(self.localtime>=event.time)then	
				event.execute()
				tremove(self.timedevents,i)
			end
		end
	end
		
	function class:ReactToCustomDanceEvent(event)
		-- mobile_fakemonkboss doesn't check whether it's hitting primary player, so check now
		if(event.source~=self.raid.players[1].combat)then return end
		
		--TODO: maybe this should be global (but we'd have to call it "TRAININGGROUNDS_yard" instead)
		local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)		
	
		-- local targetcombat=event.target
		-- local targetmobile=nil
		-- if(targetcombat)then targetmobile=targetcombat.owner end
		-- local camera=self.multisidedstrike.environment.cameramanager.camera
		
		if(event.action==TRAININGGROUNDS_JAINA_CustomDanceEventType.HIT_BY_SHATTERINGLANCE)then
			--print("flash")
			self.playerisdead=true
			self.shatteringlancehits=self.shatteringlancehits+1
			self.player.combat:FlashDamageFlash_Alert()
			--TODO: apply chilling touch stacks
			--knockback is handled by Shattering Lance itself (Aura_ChillingTouch.lua)
		elseif(event.action==TRAININGGROUNDS_JAINA_CustomDanceEventType.HIT_BY_BROADSIDE)then
			self.playerisdead=true
			self.player.combat:FlashDamageFlash_Alert()
		elseif(event.action==TRAININGGROUNDS_JAINA_CustomDanceEventType.HIT_BY_CRYSTALLINEDUST)then
			self.playerisdead=true
			self.player.combat:FlashDamageFlash_Alert()
		elseif(event.action==TRAININGGROUNDS_JAINA_CustomDanceEventType.HIT_BY_GLACIALRAY)then
			self.playerisdead=true
			self.player.combat:FlashDamageFlash_Alert()
		elseif(event.action==TRAININGGROUNDS_JAINA_CustomDanceEventType.HIT_BY_ICEFALL)then
			self.playerisdead=true
			self.player.combat:FlashDamageFlash_Alert()
		end
	end

	

	function class:ApplyChillingTouchStacks(stacks,damage)
		local auras=self.player.combat.auramodule:GetAurasByClassIfExist(TRAININGGROUNDS_JAINA_Aura_FrozenSeas)
		if(not (#auras>0))then return end
		
		local player=self.player
		-- if "damage" is true, then if player reaches 20 stacks, auto iceblock without the usual 3-5s delay.
		local auras=player.combat.auramodule:GetAurasByClassIfExist(TRAININGGROUNDS_JAINA_Aura_ChillingTouch)
		if(#auras>0)then
			local aura=auras[1]
			aura.intensity=aura.intensity+stacks
			if(aura.intensity>=20)then
				aura.intensity=20
				if(damage)then
					self:ApplyFrozenSolid()
				end
			end
		end	
	end
	

	
	--set wipe to true if the ENTIRE raid is iceblocked to avoid breaking out early.
	function class:ApplyFrozenSolid(wipe)
		local player=self.player
		local fs=player.combat:ApplyAuraByClass(TRAININGGROUNDS_JAINA_Aura_FrozenSolid,player.combat)
		fs.groupdancemodule=self
		--clear existing ChillingTouch aura (and FrozenSolid, if it already exists)
			--TODO LATER: don't apply FrozenSolid if it already exists
		local auras=player.combat.auramodule:GetAurasByClassIfExist(TRAININGGROUNDS_JAINA_Aura_ChillingTouch)
		if(#auras>0)then auras[1]:Die() end
		local auras=player.combat.auramodule:GetAurasByClassIfExist(TRAININGGROUNDS_JAINA_Aura_FrozenSolid)
		if(#auras>0)then auras[1]:Die() end		
		local xdist=player.x-self.jaina.x
		local ydist=player.y-self.jaina.y
		local dist=math.sqrt(xdist*xdist+ydist*ydist)/yard
		if(self.mode_choice==1)then
			local diststr=string.format("%.1f",dist)
			local message="Frozen "..diststr.."yd away."
			TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,2.0,false)
		end		
		--TODO: check distance to Jaina, apply duration timer
		local duration
		if(wipe~=true)then
			duration=self:GetIceblockDuration(player.x,player.y)
		else
			duration=20
		end
		fs.expiry=self.player.environment.localtime+duration
		-- must pass duration to function so both aura and iceblock will have the same duration...
		self:ApplyIceblockAndLances(player.x,player.y,duration)
	end
	
	function class:ApplyIceblockAndLances(x,y,duration)
		local player=self.player		
		local iceblock=TRAININGGROUNDS_JAINA_Decor_IceBlock.new()
		iceblock:Setup(self.environment)
		iceblock.x=x;iceblock.y=y-1
		if(duration==nil)then duration=self:GetIceblockDuration(x,y) end
		iceblock.endtime=duration		
		
		local jaina=self.jaina
		local sourcex=jaina.x
		local sourcey=jaina.y
		self:ApplyOneLance(x,y,duration,sourcex,sourcey)
		
		if(self.prismaticimage and (self.prismaticimage.dead~=true))then
			sourcex=self.prismaticimage.x
			sourcey=self.prismaticimage.y
			self:ApplyOneLance(x,y,duration,sourcex,sourcey)	
		end
	end
	
	function class:ApplyOneLance(targetx,targety,duration,sourcex,sourcey)
		local lance=TRAININGGROUNDS_JAINA_Decor_ShatteringLance.new()
		
		local angle=math.atan2(targety-sourcey,targetx-sourcex)		
		lance:Setup(self.environment)
		lance.groupdancemodule=self
		local LANCE_DIST=yard*2
		lance.x=sourcex-math.cos(angle)*LANCE_DIST;lance.y=sourcey-math.sin(angle)*LANCE_DIST
		lance.z=yard*4
		lance.currentfacing=angle--+math.pi
		
		if(self.mode_choice==1)then		
			local cone=TRAININGGROUNDS_Telegraph_Cone_FlashOnce.new()
			local sweepangle=(math.pi*2.0*0.001)
			local radius=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(200)	--TODO: fix magic number		
			local x1=lance.x
			local y1=lance.y		
			cone:Setup(self.environment)
			cone:PositionCone(x1,y1,angle,sweepangle,radius)
			cone:SetColor(1,1,0,1)
		end	
	end
	
	
	
	function class:GetIceblockDuration(x,y)
		local xdist=x-self.jaina.x
		local ydist=y-self.jaina.y
		local dist=math.sqrt(xdist*xdist+ydist*ydist)/yard
		if(dist<=7.5)then
			return 4.0+3.0*math.random()
		elseif(dist<=15.0)then
			return 6.0+6.0*math.random()
		else
			return 9.0+11.0*math.random()
		end	
	end
	
	
	function class:ApplyMassFrozenSolid()
		-- apply player iceblock (disregard preexisting iceblock)
		self:ApplyFrozenSolid(true)
		
		-- apply 9 other player iceblocks (disregard preexisting iceblocks)
		local jaina=self.jaina
		local angle=math.atan2(jaina.y,jaina.x)
		local dist=math.sqrt(jaina.x*jaina.x+jaina.y*jaina.y)
		-- 5 players near Jaina, towards center
		for i=1,5 do
			local xbase=math.cos(angle)*(dist-yard*3)
			local ybase=math.sin(angle)*(dist-yard*3)
			local x=xbase+math.random()*yard*4-yard*2
			local y=ybase+math.random()*yard*4-yard*2
			self:ApplyIceblockAndLances(x,y,20)
		end		
		-- 2 players not in melee range for whatever reason
		for i=1,2 do
			local xbase=math.cos(angle)*(dist-yard*10)
			local ybase=math.sin(angle)*(dist-yard*10)
			local x=xbase+math.random()*yard*6-yard*3
			local y=ybase+math.random()*yard*6-yard*3
			self:ApplyIceblockAndLances(x,y,20)
		end				
		-- 1 main tank, and they get their own function
		self:MainTankFreeze(20)
		-- 1 offtank near Jaina, to the side		
		local xbase=math.cos(angle-math.pi/32)*(dist)
		local ybase=math.sin(angle-math.pi/32)*(dist)
		local x=xbase+math.random()*yard*2-yard*1
		local y=ybase+math.random()*yard*2-yard*1
		self:ApplyIceblockAndLances(x,y,20)		
	end
	

	function class:MainTankFreeze(duration)
		if(duration==nil)then duration=4.0 end
		local jaina=self.jaina
		local angle=math.atan2(jaina.y,jaina.x)
		local dist=math.sqrt(jaina.x*jaina.x+jaina.y*jaina.y)	
		-- 1 maintank near Jaina, towards edge
		local xbase=math.cos(angle)*(dist+yard*3)
		local ybase=math.sin(angle)*(dist+yard*3)
		local x=xbase+math.random()*yard*2-yard*1
		local y=ybase+math.random()*yard*2-yard*1
		self:ApplyIceblockAndLances(x,y,duration)		
	end
	

	function class:GlacialRayEmote(arrows)
		if(self.mode_choice==1)then
			local iconsize="20"
			local icon="\124Tinterface\\icons\\ability_mage_rayoffrost:"..iconsize.."\124t"
			local link="\124cffff0000\124Hspell:288345\124h[Glacial Ray]\124h\124r"			
			local message=icon..""..link.." — dodge!"
			TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,1.0,true)		
		end
	end
	
	function class:GlacialRayArrows()
		if(self.freezeangle)then
			local basex=self.jaina.x+yard*5*math.cos(self.freezeangle)
			local basey=self.jaina.y+yard*5*math.sin(self.freezeangle)
			for i=-1,1,2 do
				local arrowangle=self.freezeangle+math.pi/2*i
				local x1=basex+math.cos(arrowangle)*yard*3
				local y1=basey+math.sin(arrowangle)*yard*3
				local x2=basex+math.cos(arrowangle)*yard*8
				local y2=basey+math.sin(arrowangle)*yard*8
				local arrow=self:Arrow(x1,y1,x2,y2,10,20,1,1,1,1,7)
			end
		end	
	end
	
	function class:InverseGlacialRayArrow()
		if(self.freezeangle)then
			local basex=self.jaina.x+yard*5*math.cos(self.freezeangle)
			local basey=self.jaina.y+yard*5*math.sin(self.freezeangle)
			local arrow=self:Arrow(self.player.x,self.player.y,basex,basey,10,20,1,1,1,1,7)
			
		end
	end
	
	function class:KeepDodgingEmote()
		if(self.mode_choice==1)then
			local message="Keep dodging!"
			TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,1.0,true)	
		end
	end
	
	function class:NowFreezeEmote()
		if(self.mode_choice==1)then		
			local iconsize="20"
			local icon="\124Tinterface\\icons\\spell_hunter_icetrap:"..iconsize.."\124t"
			local link="\124cffff0000\124Hspell:288297\124h[Arctic Ground]\124h\124r"			
			local message=icon..""..link.." — dodge!"
			local message="Now freeze yourself on "..link.."!"
			TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,1.0,true)	
		end
	end	

	function class:RunAwayEmote()
		if(self.mode_choice==1)then		
			local iconsize="20"
			local icon="\124Tinterface\\icons\\spell_frost_frostblast:"..iconsize.."\124t"
			local link="\124cffff0000\124Hspell:288297\124h[Shattering Lance]\124h\124r"			
			local message="Move away from "..link.." as soon as you can!"
			TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,1.0,true)	
		end
	end		
	
	function class:Arrow(x1,y1,x2,y2,width,radius,R,G,B,A,lifespan)
		if(self.mode_choice==2)then return nil end
		local testarrow=TRAININGGROUNDS_Telegraph_MovementArrow.new()
		testarrow:Setup(self.environment.game.environment_gameplay)
		--TODO: should testarrow itself have SetArrow which calls drawable:SetArrow?
				-- (in a perfectly encapsulated world, the answer is obviously yes)
		testarrow.drawable:SetColor(R,G,B,A)
		testarrow.drawable:SetArrow(x1,y1,x2,y2,width,radius)
		testarrow.visible=true
		testarrow.drawable.visible=true
		testarrow.expirytime=self.environment.localtime+lifespan
		--TRAININGGROUNDS_FrameVisibilityCheck(testarrow.drawable.frame)
		tinsert(self.arrows,testarrow)
		
		return testarrow
	end
	function class:ClearArrows()
		for i=1,#self.arrows do
			self.arrows[i]:Die()
		end
	end
	
	
	
	function class:GetEndOfCycleDelay()
		return 3.0
	end
	
	--TODO: cleanup (and cleanup on base groupdancemodule too?)
	function class:Cleanup()
		--TODO: NYI
	end
end
