

do
	local super=TRAININGGROUNDS_Scenario
	TRAININGGROUNDS_JAINA_Scenario_Jaina = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JAINA_Scenario_Jaina

	
	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
	
	function class:Populate()
		super.Populate(self)				
			
		self:CreateBossController()
		
		local currentplayer=self.raid.rdps[1]
		self.controls:SetPlayer(currentplayer)
		currentplayer:SetPlayerAppearance()
		local relevant=TRAININGGROUNDS_Aura_PlayerControlled.new()
		relevant:Setup(currentplayer.combat,currentplayer.combat,currentplayer:GetLocalTime())			

		self.jaina.groupdancemodule:GetIntoInitialPosition()
		
		--local YDIFF=100
		local XDIFF=125
		local YDIFF=0
		
		self.startbuttons={}
		--!!!

		local startbutton	
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2-XDIFF
		startbutton.y=self.environment.game.window.frame:GetHeight()/2-200+YDIFF
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Hints\rON")
		startbutton.drawable.frame:SetScript("OnClick",function()					
					self.jaina.groupdancemodule.mode_choice=1		
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)		
		local startbutton	
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2+XDIFF
		startbutton.y=self.environment.game.window.frame:GetHeight()/2-200-YDIFF
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Hints\rOFF")
		startbutton.drawable.frame:SetScript("OnClick",function()
					self.jaina.groupdancemodule.mode_choice=2
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)		

			

	end

	function class:SetCamera()
		--self.environment.game.environment_gameplay.cameramanager.camera=TRAININGGROUNDS_Camera3D.new()
		--self.environment.game.environment_gameplay.cameramanager.camera=TRAININGGROUNDS_Camera.new()
		self.environment.game.environment_gameplay.cameramanager.camera=TRAININGGROUNDS_Camera_AdjustableZoom.new()
		self.environment.game.environment_gameplay.cameramanager.camera:Setup(self.environment.game.environment_gameplay)
	end	

	--TODO: somehow connect camera+playercontrols, since they're usually codependent
	function class:CreatePlayerControls()
		--local controls = TRAININGGROUNDS_ScenarioPlayerControls_CharacterMode_3D.new()
		local controls = TRAININGGROUNDS_ScenarioPlayerControls_CharacterMode.new()
		controls:Setup(self.environment,self)			
		self.controls=controls
	end
	
	function class:CreateBossController()
		self.jaina=TRAININGGROUNDS_JAINA_BossController_Jaina.new()
		--TODO: at this point it becomes very awkward that scenario.environment is not scenario.environment_gameplay
		self.jaina:Setup(self.environment.game.environment_gameplay,self)
		self.jaina:CreateBoss()		
		self.jaina.groupdancemodule.bosscontroller=self.jaina
		self.jaina.groupdancemodule:PopulateDefaultRaid(self.environment.game.environment_gameplay)
	end
	
	function class:OnStartButton()
		for i=1,#self.startbuttons do
			self.startbuttons[i].visible=false	
			self.startbuttons[i].drawable.frame:EnableMouse(false)
		end
		self.jaina.groupdancemodule:StartTestCycle()
	end
	
	function class:ShowButtons()
		for i=1,#self.startbuttons do
			self.startbuttons[i].visible=true	
			self.startbuttons[i].drawable.frame:EnableMouse(true)
		end	
	end

	function class:OnEscapeKey()
		self.environment.game:LoadScenarioByClass(TRAININGGROUNDS_Scenario_Menu)
	end
	
	
	function class:PostMove(elapsed)
		super.PostMove(elapsed)
		--print("PostMove",self.player)
		if(self.player)then
			local dist=math.sqrt(self.player.x*self.player.x+self.player.y*self.player.y)
			local MAX_DIST=yard*50
			if(dist>MAX_DIST)then
				local unitvectorx=self.player.x/dist
				local unitvectory=self.player.y/dist
				self.player.x=unitvectorx*MAX_DIST
				self.player.y=unitvectory*MAX_DIST
			end
			-- if(self.TEMPfloor)then
				-- self.TEMPfloor.x=self.player.x
				-- self.TEMPfloor.y=self.player.y
			-- end
			--print("PostMove",self.floor.x,self.floor.y)
		end
	end

	
	
	
end
