do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_UUNAT_Decor_Floor=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_UUNAT_Decor_Floor
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=0
	end

	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_UUNAT_Drawable_Floor.new()
		self.drawable:Setup(self,self.environment)
	end
	
end


do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_UUNAT_Drawable_Floor=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_UUNAT_Drawable_Floor
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false
		--self.modelfilename="spells/8fx_jaina_pileofsnow.m2"	;self.defaultanimation=158
		--self.modelfilename="world/generic/activedoodads/christmas/snowballmound01.m2"
		--self.modelfilename="spells/8fx_shrineraid_uunat_obliviontear_areatrigger.m2";self.defaultanimation=158
		self.modelfilename="world/expansion06/doodads/dungeon/doodads/7du_tombofsargeras_councilfloor01.m2"		
		--self.modelfilename="world/expansion06/doodads/eredar/7er_ancient_stone_floor_b01.m2"
		self.scale3D=1*1.1	--TODO: probably move to modelinfo
		self.positionmultiplier=1	--TODO: move to modelinfo
		self.camerapositionmultiplier=0.6	--TODO: move to modelinfo
		self.zsortoffset3D=10	--measured in yards.  TODO: move to modelinfo
		
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.floorframelayer
	end
	

end

do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_UUNAT_Decor_Skybox=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_UUNAT_Decor_Skybox
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=0
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_UUNAT_Drawable_Skybox.new()
		self.drawable:Setup(self,self.environment)
	end
end


do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_UUNAT_Drawable_Skybox=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_UUNAT_Drawable_Skybox
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false
		self.modelfilename="spells/8fx_shrineraid_uunat_nzothsrealm.m2"
		self.scale3D=1	--TODO: probably move to modelinfo
		self.positionmultiplier=1	--TODO: move to modelinfo
		self.camerapositionmultiplier=0.6	--TODO: move to modelinfo
		self.zsortoffset3D=10	--measured in yards.  TODO: move to modelinfo
		self.defaultanimation=158
	end	
	function class:CreateFrame()
		super.CreateFrame(self)
		self.frames={}
		tinsert(self.frames,self.frame)
		self.back=TRAININGGROUNDS_ReusableFrames:GetFrame()
		tinsert(self.frames,self.back)
		
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.skyboxframelayer
	end
	function class:ArrangeFrame3D(...)
		super.ArrangeFrame3D(self,...)
		self.back:SetParent(self.parentframe)
		self.back:ClearAllPoints()
		self.back:SetAllPoints(self.parentframe)
		self.back.texture:Show()
		self.back.texture:SetAllPoints(self.back)
		self.back.texture:SetColorTexture(0,0,0,1.0)
	end
end