do
	local super=TRAININGGROUNDS_Drawable
	TRAININGGROUNDS_Drawable_Polygon = TRAININGGROUNDS_inheritsFrom(super)

	-- function TRAININGGROUNDS_Drawable_Polygon:SetCustomInfo()
		-- super.SetCustomInfo(self)
		-- --TODO: probably move flag_redraw to base Drawable
		-- self.flag_redraw=true
	-- end
	
	function TRAININGGROUNDS_Drawable_Polygon:SetFrameAppearance()
		--texture will be setup during TAXIFRAME_TextureAdd
		self.width=100
		self.height=100		
		--TODO: width/heigth should go here, but should we move SetParent+SetPoint somewhere else?
		self.frame:SetParent(self.parentframe)
		self.frame:SetPoint("TOPLEFT",self.parentframe,"CENTER",0,0)
		self.frame:Show()		
		self.frame:SetWidth(self.width)
		self.frame:SetHeight(self.height)		
	end
	
	function TRAININGGROUNDS_Drawable_Polygon:SetVertices(x1,y1,x2,y2,x3,y3)
		--print("D_P:SetVertices")
		--print("Parentframe size: ",self.parentframe:GetSize())
		self.x1=x1
		self.y1=y1
		self.x2=x2
		self.y2=y2
		self.x3=x3
		self.y3=y3
		--TAXIFRAME_TextureAdd(self.frame,nil,nil,nil,nil,x1,y1,x2,y2,x3,y3)
		--self.frame:SetSize(self.parentframe:GetWidth()*3,self.parentframe:GetHeight()*3)
		--print("Poly size:",self.frame:GetWidth(),self.frame:GetHeight())
		--self.frame.texture:SetSize(self.frame:GetWidth(),self.frame:GetHeight())
		--TODO: divide by frame.width instead of hardcoding 100?

		--TODO: drawable_polygon:GetYStretchMultiplier()
		local ystretch=self.owner.environment.cameramanager.camera.ystretch
		--TAXIFRAME_TextureAdd(self.frame,nil,nil,nil,nil,x1,y1,x2,y2,x3,y3)
		TAXIFRAME_TextureAdd(self.frame,100,1,1,1,x1*0.01,-y1*0.01*ystretch,x2*0.01,-y2*0.01*ystretch,x3*0.01,-y3*0.01*ystretch)		
	end
	
	--TODO: Drawable:SetColor (can call drawable_model:setlighting)
	function TRAININGGROUNDS_Drawable_Polygon:SetColor(R,G,B,A)
		self.frame.texture:SetGradientAlpha("HORIZONTAL",R,G,B,A,R,G,B,A)
	end
	
	-- --TODO:
	function TRAININGGROUNDS_Drawable_Polygon:ArrangeFrame(parentanchor,x,y,wid,hgt,yaw,pitch)		
		-- if(self.flag_redraw)then
			-- self.flag_redraw=false
			-- TAXIFRAME_TextureAdd(self.frame,100,1,1,1,x1*0.01,-y1*0.01,x2*0.01,-y2*0.01,x3*0.01,-y3*0.01)
		-- end
		self.frame:SetParent(self.parentframe)
		
	end	
	function TRAININGGROUNDS_Drawable_Polygon:SetFrameSizeAndOrientation(wid,hgt,yaw,pitch)
		--TODO: (?)
		--do nothing, maybe		
	end
	
	
	
	
end
