do
	local super=TRAININGGROUNDS_Drawable
	TRAININGGROUNDS_Drawable_BossTitleBar=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_Drawable_BossTitleBar
	
	function class:CreateFrame()
		self.frame=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.textframe=TRAININGGROUNDS_ReusableFrames:GetFrame()	
		self.bar_back=TRAININGGROUNDS_ReusableFrames:GetFrame()	
		self.bar_fill=TRAININGGROUNDS_ReusableFrames:GetFrame()	
		
		self.frames={}
		tinsert(self.frames,self.frame)
		tinsert(self.frames,self.textframe)
		tinsert(self.frames,self.bar_back)
		tinsert(self.frames,self.bar_fill)
	end
	
	function class:SetFrameAppearance()
	
		-- Old screen size:
		-- --self.healthbarwidth=600	--standard
		-- self.healthbarwidth=750		--prolonged fights
		
		-- New screen size:
		-- self.healthbarwidth=750	--standard
		self.healthbarwidth=1000		--prolonged fights

	
		-- --override; don't call super while overriding
		
		self.textframe:SetAllPoints(self.frame)
		self.bar_back.texture:Show()
		--self.bar_back.texture:SetColorTexture(0.125,0.125,0.125,1)
		self.bar_back.texture:SetColorTexture(0.5,0.5,0.5,0.5)
		self.bar_back:SetPoint("BOTTOM",self.frame,"BOTTOM",0,0)
		--self.bar_back:SetPoint("LEFT",self.frame,"LEFT",50,0)
		--self.bar_back:SetPoint("RIGHT",self.frame,"RIGHT",-50,0)
		--self.bar_back:SetHeight(7)
		self.bar_back:SetSize(self.healthbarwidth,5)
		--local w=self.bar_back:GetWidth()
		self.bar_fill.texture:Show()
		--self.bar_fill.texture:SetColorTexture(0.9,0.9,0.9,1)
		self.bar_fill.texture:SetColorTexture(1,1,1,1)
		--self.bar_fill:SetAllPoints(self.bar_back)
		self.bar_fill:SetPoint("BOTTOMLEFT",self.bar_back,"BOTTOMLEFT",0,0)		
		--self.bar_fill:SetSize(self.healthbarwidth*.6,5)	--taloc
		self.bar_fill:SetSize(self.healthbarwidth*1.0,5)
	end
	
	function class:SetFrameLevel()
		--override; don't call super while overriding
		if(self.frames)then
			for i=1,#self.frames do
				self.frames[i]:SetFrameLevel(self.framelayer.level)
			end
		end
		self.bar_fill:SetFrameLevel(self.framelayer.level+1)
		--self.frame:SetFrameLevel(self.framelayer.level)
	end
end