local keep_this_line_here_to_avoid_lua_errors_upon_addon_load=1

--TODO NEXT: cvars not reliably restored after shutdown or error -- might have to be reverse restore order after all
-- TODO LATER: scenarioplayercontrols for multisidedstrike
	-- -- lock player position to camerafacing3D.  (non-player characters don't need to)
	
	
-- This page is intentionally left blank
-- ...unless you happen to have stumbled across it during a point of development in which it wasn't left blank.

-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------

-- Unfinished code was removed; check local archives.


-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------




-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------


-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
do
	-- WORK IN PROGRESS
	
	local TYPE_MELEE=1
	local TYPE_RANGED=2
	
	local super=TRAININGGROUNDS_Spell
	TRAININGGROUNDS_Spell_SampleTutorialAttack = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_Spell_SampleTutorialAttack
	
	function class:SetCustomInfo()
		TRAININGGROUNDS_Spell.SetCustomInfo(self)
		self.projectileclass=TRAININGGROUNDS_Projectile_SampleMeleeAttack
		
		self.basecastduration=0
		self.range=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(40.0)
		-- new to SampleTutorialAttack, attacks within meleedistance will be treated differently
		self.meleedistance=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(6.0)

		self.range=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(40.0)
	end

	
	function class:ConfirmInstance()
		-- in addition to flagging this spell as an instance,
		self.instance=true
		-- we also now determine whether this is melee or ranged
		local currentdist=self.castercombat.owner:GetSpellDistanceToMobile(self.targetcombat.owner,self)
		if(currentdist<=self.meleedistance)then
			self.rangetype=TYPE_MELEE
		else
			self.rangetype=TYPE_RANGED
		end
	end	
end

-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------


--TODO: some of these functions should be moved out of default camera

local super=TRAININGGROUNDS_Camera
TRAININGGROUNDS_Camera_AdjustableZoom = TRAININGGROUNDS_inheritsFrom(super)
local class=TRAININGGROUNDS_Camera_AdjustableZoom

function class:SetCustomInfo()
	super.SetCustomInfo(self)
	self.nudgex=0
	self.nudgey=0
end

--TODO: camera and scenario have their own GetPlayerInput.  should we combine camera+scenario playerinput?
function class:GetPlayerInput(elapsed)
	--TODO NEXT: take a look at zoom controls from old version
	--TODO: camera controls should go in scenariocontrols
	local keys=self.environment.game.keys	
	local delta=keys.wmouse.pressed
	if(delta)then
		self:AdjustZoomViaScrollWheel(delta)
	end	
	--local SCROLL_SPEED=200	
	local SCROLL_SPEED=2000
	local RECALL_SPEED=3000
	if(keys.left.current)then
		self.nudgex=self.nudgex-SCROLL_SPEED*elapsed*(1/self.zoom)
	end
	if(keys.right.current)then
		self.nudgex=self.nudgex+SCROLL_SPEED*elapsed*(1/self.zoom)
	end	
	if(keys.up.current)then
		self.nudgey=self.nudgey+SCROLL_SPEED*elapsed*(1/self.zoom)
	end
	if(keys.down.current)then
		self.nudgey=self.nudgey-SCROLL_SPEED*elapsed*(1/self.zoom)
	end	
	
	local dist=math.sqrt(self.nudgex*self.nudgex+self.nudgey*self.nudgey)
	local olddist=dist
	if(dist>0)then
		local unitvectorx=self.nudgex/dist
		local unitvectory=self.nudgey/dist			
		local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
		local multiplier=math.sqrt(self.zoom)
		if(multiplier>1)then multiplier=1 end
		if(dist>yard*70*(multiplier))then
			dist=yard*70*(multiplier)
		end
		if(not (keys.left.current or keys.right.current or keys.up.current or keys.down.current))then 				
			dist=dist-RECALL_SPEED*elapsed*(1/self.zoom)
			if(dist<0)then dist=0 end
		end
		if(dist~=olddist)then			
			self.nudgex=unitvectorx*dist
			self.nudgey=unitvectory*dist
		end
		
	end
	
	
end

function class:MoveToFocus(elapsed)
--TODO: smoother scrolling

	local keys=self.environment.game.keys	
	

	if(#self.focus==0)then return end
	
	local xmin,ymin,xmax,ymax
	local xtotal=0
	local ytotal=0
	for i=1,#self.focus do
		local focus=self.focus[i]
		if((not xmin) or (xmin>focus.x))then xmin=focus.x end
		if((not xmax) or (xmax<focus.x))then xmax=focus.x end
		if((not ymin) or (ymin>focus.y))then ymin=focus.y end
		if((not ymax) or (ymax<focus.y))then ymax=focus.y end
		xtotal=xtotal+focus.x
		ytotal=ytotal+focus.y
	end
	local extra=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(5)
	xmin=xmin-extra
	ymin=ymin-extra
	xmax=xmax+extra
	ymax=ymax+extra
	--print(xmin,xmax,ymin,ymax)
	-- local xavg=xtotal/#self.focus	--TODO: maybe just (max+min)/2
	-- local yavg=ytotal/#self.focus
	local xavg=(xmax+xmin)/2
	local yavg=(ymax+ymin)/2
	--self.targetlocation={x=xavg,y=yavg}

	local arenaradius=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(50)
	
	local minzoom=0.35
	local maxzoom=2.5
	local multiplier=math.sqrt((self.zoom-minzoom)/maxzoom)
	local xloc,yloc=xavg*multiplier,yavg*multiplier
	
	--print(self.zoom,multiplier)
	--self.targetlocation={x=xloc,y=yloc}
	
	self.targetlocation={x=xavg+self.nudgex,y=yavg+self.nudgey}
	
end







-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------


local super=TRAININGGROUNDS_Aura_Facing
TRAININGGROUNDS_Aura_Facing_Direction_WhileCasting=TRAININGGROUNDS_inheritsFrom(super)
local class=TRAININGGROUNDS_Aura_Facing_Direction_WhileCasting

function class:SetCustomInfo()
	self.baseduration=nil
	self.turnspeed=5
end
function class:Step()
	if(not(self.castercombat.castedspell or self.castercombat.channeledspell))then
		--TODO: not sure if OnExpiry will always call Die
		self:OnExpiry()
	end
end
function class:GetTargetFacing()	
	return self.targetfacing	-- targetfacing must be set by aura's creator
end

-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_OPULENCE_Decor_FlamesFloor=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_OPULENCE_Decor_FlamesFloor
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=0
	end

	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_OPULENCE_Drawable_FlamesFloor.new()
		self.drawable:Setup(self,self.environment)
	end
	
end


do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_OPULENCE_Drawable_FlamesFloor=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_OPULENCE_Drawable_FlamesFloor
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false
		-- self.modelfilename="world/expansion06/doodads/dungeon/doodads/7du_tombofsargeras_councilfloor01.m2"		
		-- self.scale3D=0.375	--TODO: probably move to modelinfo
		-- self.positionmultiplier=1	--TODO: move to modelinfo
		-- self.camerapositionmultiplier=0.6	--TODO: move to modelinfo
		-- self.zsortoffset3D=10	--measured in yards.  TODO: move to modelinfo
		
		self.modelfilename="world/expansion07/doodads/dungeon/doodads/8du_nazmirraid_elevator01.m2"		
		self.scale3D=0.375	--TODO: probably move to modelinfo
		self.positionmultiplier=1	--TODO: move to modelinfo
		self.camerapositionmultiplier=0.61	--TODO: move to modelinfo
		self.zsortoffset3D=10	--measured in yards.  TODO: move to modelinfo

		-- self.modelfilename="world/expansion07/doodads/dungeon/doodads/8du_zuldazarraid_elevator01.m2"		
		-- self.scale3D=1	--TODO: probably move to modelinfo
		-- self.positionmultiplier=1	--TODO: move to modelinfo
		-- self.camerapositionmultiplier=0.6	--TODO: move to modelinfo
		-- self.zsortoffset3D=10	--measured in yards.  TODO: move to modelinfo	

		-- self.modelfilename="world/expansion05/doodads/draenei/6dr_draenei_stone_floor_b03.m2"
		-- self.scale3D=1	--TODO: probably move to modelinfo
		-- self.positionmultiplier=1	--TODO: move to modelinfo
		-- self.camerapositionmultiplier=0.6	--TODO: move to modelinfo
		-- self.zsortoffset3D=10	--measured in yards.  TODO: move to modelinfo
		
		-- self.modelfilename="world/expansion06/doodads/eredar/7er_ancient_stone_floor_b01.m2"
		-- self.scale3D=1	--TODO: probably move to modelinfo
		-- self.positionmultiplier=1	--TODO: move to modelinfo
		-- self.camerapositionmultiplier=0.6	--TODO: move to modelinfo
		-- self.zsortoffset3D=10	--measured in yards.  TODO: move to modelinfo		
		
		-- self.modelfilename="world/expansion05/doodads/dungeon/doodads/6du_arakkoadungeon_glassfloor_01.m2" 
		-- self.scale3D=0.5	--TODO: probably move to modelinfo
		-- self.positionmultiplier=1	--TODO: move to modelinfo
		-- self.camerapositionmultiplier=0.6	--TODO: move to modelinfo
		-- self.zsortoffset3D=10	--measured in yards.  TODO: move to modelinfo
		

		-- --!!!
		-- self.modelfilename="spells/target_water_state_centeronly.m2"
		-- self.scale3D=0.375	--TODO: probably move to modelinfo
		-- self.positionmultiplier=1	--TODO: move to modelinfo
		-- self.camerapositionmultiplier=0.61	--TODO: move to modelinfo
		-- self.zsortoffset3D=10	--measured in yards.  TODO: move to modelinfo		
		-- self.defaultanimation=158
	end
	
	-- -- for zandalarraid_elevator only
	-- function class:Get3DPositionCoords()
		-- local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
		-- return self.x,self.y,self.z+yard*-0.625
	-- end	
	
	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.telegraphframelayer
	end
	
end

-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------

-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------

do
	--TODO LATER: does RestartGx help us anywhere (not necessarily here)
	
	-- TODO LATER: cvar override makes a fairly strong case for traininggrounds to be a singleton class
 	private_TRAININGGROUNDS_CVars = {}
	local class=private_TRAININGGROUNDS_CVars
	class.__index = class	
	
	function class.new()
		local self=setmetatable({}, class)
		return self
	end
	
	function class:Setup()
		self.cvarnames={}
		tinsert(self.cvarnames,"enableMouseSpeed")
		tinsert(self.cvarnames,"mouseSpeed")
		self.cvarvalues={}
	end
	
	function class:SaveAll()
		for i=1,#self.cvarnames do
			local cvarname=self.cvarnames[i]			
			self.cvarvalues[cvarname]=GetCVar(cvarname)
			--print("Saving",cvarname,self.cvarvalues[cvarname])
		end
	end
	
	function class:Override(cvarname,value)
		SetCVar(cvarname,value)
	end
	
	function class:Restore(cvarname)
		SetCVar(cvarname,self.cvarvalues[cvarname])
	end
	
	function class:RestoreAll()
		--TODO: does it matter which order we do this in?  does it need to be reverse order instead?
		--TODO NEXT: cvars not reliably restored after an error -- might have to be reverse order after all
		for i=1,#self.cvarnames do
			local cvarname=self.cvarnames[i]
			--print("Restoring",cvarname,self.cvarvalues[cvarname])
			self.cvarvalues[cvarname]=SetCVar(cvarname)
		end	
	end
	
	TRAININGGROUNDS_CVars=private_TRAININGGROUNDS_CVars.new()
	TRAININGGROUNDS_CVars:Setup()
	
end

-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------



-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------

-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------


do
	--TODO: pass localtime to function
	function TEMP_CastSpellOnTargetMobile(castermobile,spellclass,targetmobile)
		--TODO: not recommended to use this; spells are designed to be queued from an instance of a spell in the caster's spellbook	
							-- which (among other things) have had Setup run on them
	

	
		local targetcombat=nil
		if(targetmobile)then
			targetcombat=targetmobile.combat
		end
		
		--TODO: combatmodule:SetTarget (and fix everything it breaks)		
		castermobile.combat.targetcombat=targetcombat
		
		local queuespell=spellclass:NewQueue()
		queuespell.castercombat=castermobile.combat
		queuespell.targetcombat=targetcombat
		--print("Targetcombat:",queuespell.targetcombat)
		local errorcode=castermobile.combat:TryQueue(queuespell)
		
		return queuespell
	end
end

